#include <GL/glut.h>
#include <assert.h>
#include "gfxio.h"
#include <string.h>
#include <stdio.h>
#include "RvDisplayMaterial.h"

#define VIDEOREZ 512


///////////////////////////////////////////////////////

RvDisplayMaterial::RvDisplayMaterial() {
	ambient [ 0 ] = 0.2f;
	ambient [ 1 ] = 0.2f;
	ambient [ 2 ] = 0.2f;
	ambient [ 3 ] = 1.0f;
	diffuse [ 0 ] = 0.8f;
	diffuse [ 1 ] = 0.8f;
	diffuse [ 2 ] = 0.8f;
	diffuse [ 3 ] = 1.0f;
	specular[ 0 ] = 0.0f;
	specular[ 1 ] = 0.0f;
	specular[ 2 ] = 0.0f;
	specular[ 3 ] = 1.0f;
	emission[ 0 ] = 0.0f;
	emission[ 1 ] = 0.0f;
	emission[ 2 ] = 0.0f;
	emission[ 3 ] = 1.0f;
	shininess		 = 0.0f;
	alpha				 = 1.0f;
}


// use the function loadTiff(name, data, &x,&y,&depth);
// to load the texture into your texture variable
void RvDisplayMaterial::setTiffTexture(char *name,int mipm)
{
	// ....
}

void RvDisplayMaterial::initGL()
{
	std::cerr << "############# INIT GL " << std::endl;
	// If textured to all the glTextureparameteri, glBindTexture, glPixelStorei etc.
	// ....
}

void RvDisplayMaterial::load(char *fname) {
	// Copy texture name into a field
	// Save state of textured or not
	// ....
	load();
}

void RvDisplayMaterial::setTexture(char *fname) {
	// Copy texture name into a field
	// Save state of textured or not
	// ....
	// call setTiffTexture 
	load();
}

void RvDisplayMaterial::load() {
	// load the texture
	// ....
	initGL();
}


void RvDisplayMaterial::loadGL() {

	glMaterialfv( GL_FRONT_AND_BACK, GL_AMBIENT,	 &ambient[0] );
	glMaterialfv( GL_FRONT_AND_BACK, GL_DIFFUSE,	 &diffuse[0] );
	glMaterialfv( GL_FRONT_AND_BACK, GL_SPECULAR,	&specular[0] );
	glMaterialfv( GL_FRONT_AND_BACK, GL_EMISSION,	&emission[0] );
	glMaterialf(	GL_FRONT_AND_BACK, GL_SHININESS, shininess );

	int win = glutGetWindow();

	// If textured perform the glBind/glParameteri/TexEnv and glEnable
	// if not textured, disable texturing
	// ....
}

//////////////////////////////////////////////////////////
