#include "RvDefs.h"
#include "RvMesh.h"
#include <stdio.h>
#include <string.h>

///////////////////////////////////////////////////////////////////////////////
RvMesh::RvMesh() :  primitiveGroup(NULL), material(NULL), vertex(NULL), nPrimitiveGroup(0) {

}

RvMesh::~RvMesh() {
 if (primitiveGroup)
    delete [] primitiveGroup;
}

///////////////////////////////////////////////////////////////////////////////
bool RvMesh::init() {
  glInterleavedArrays( GL_T2F_N3F_V3F, 0, (float*)vertex );
  material->loadGL();

/*
  glEnableClientState( GL_VERTEX_ARRAY );
  glVertexPointer(  3, GL_FLOAT, 0, vertex );

  glEnableClientState( GL_TEXTURE_COORD_ARRAY );
  glTexCoordPointer(2, GL_FLOAT, 0, texVertex );

  glEnableClientState( GL_NORMRV_ARRAY );
  glNormalPointer( GL_FLOAT, 0, vrtxNormal );
*/
  return true;
}

///////////////////////////////////////////////////////////////////////////////
bool RvMesh::render() {
  for ( unsigned i = 0; i < nPrimitiveGroup; i++ ) {
    glDrawElements( primitiveGroup[i].type, primitiveGroup[i].numIndices,
                    GL_UNSIGNED_SHORT,      primitiveGroup[i].indices );
    //glDrawRangeElements ( primitiveGroup[i].type, 0, primitiveGroup[i].numIndices,primitiveGroup[i].numIndices,
     //                     GL_UNSIGNED_SHORT,      primitiveGroup[i].indices );
  }
  return true;
}

///////////////////////////////////////////////////////////////////////////////
