#ifndef RV_SYS_H
#define RV_SYS_H

#define aluint unsigned int

#ifdef irix

#include <sys/types.h>
#include <sys/stat.h>
#include <sys/resource.h>
#include <sys/prctl.h>
#include <ulocks.h>
#include <sys/schedctl.h>
#include <unistd.h>
#include <errno.h>
#include <poll.h>
#include <signal.h>

#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>

#include <stropts.h>
#include <stdio.h>
#include <string.h>
#include <sys/time.h>

#endif


#ifdef linux

#include <sys/types.h>
#include <sys/stat.h>
#include <sys/resource.h>
#include <sys/prctl.h>
//#include <ulocks.h>
//#include <sys/schedctl.h>
#include <unistd.h>
#include <errno.h>
#include <poll.h>
#include <signal.h>

#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>

#include <stropts.h>
#include <stdio.h>
#include <string.h>
#include <sys/time.h>

#include <pthread.h>
#include <semaphore.h>

#endif


#if _WIN32
//#include <windows.h>
#include <signal.h>
#include <stdio.h>
#include <string.h>

//#ifndef OS_CE
//#	include <process.h>
//#	include <winsock2.h>
//#endif

#endif


//////////////////////////////////////////////////////////////


aluint RvInitSys();

void RvSleep(aluint t);  // t in millisec.

double RvGetSysTime();	// return system time in seconds since the last RvInitSys;








#endif
