#ifndef _BMP_H_
#define _BMP_H_

#if defined (irix) || defined (OS_IRIX)
	typedef unsigned char bool;
#endif

class Bmp {
  // Private data
  ////////////////////////////////////////////////////////////////////.........
  //struct BmpHeader;
  //struct BmpInfo;
public:
  Bmp();
  Bmp( const char*filename );
  ~Bmp();
  // Public data
  ////////////////////////////////////////////////////////////////////.........
  // pixel array
  unsigned char *data;
  // Width of Image
  unsigned width;
  // Height of Image
  unsigned height;
  // name
  char filename[ 256 ];
  // Methods
  ////////////////////////////////////////////////////////////////////.........
  // load a bmp file pointed by filename
  bool load( const char *filename );
  // save a bmp file pointed by filename
  bool save( const char *filename );
};
#endif


