/* A Bison parser, made by GNU Bison 1.875b.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0

/* If NAME_PREFIX is specified substitute the variables and functions
   names.  */
#define yyparse yy1parse
#define yylex   yy1lex
#define yyerror yy1error
#define yylval  yy1lval
#define yychar  yy1char
#define yydebug yy1debug
#define yynerrs yy1nerrs


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     VERTEX = 258,
     VERTEX_NORMAL = 259,
     TEXTURE_COORD = 260,
     MATERIAL = 261,
     USE_MAP = 262,
     USE_MATERIAL = 263,
     GROUP = 264,
     SMOOTH_GROUP = 265,
     SHADOW_OBJECT = 266,
     MAP_LIB = 267,
     CINTERP = 268,
     MATERIAL_LIB = 269,
     RES = 270,
     DISPLACEMENTMAP = 271,
     RANDOM = 272,
     SEPARATOR = 273,
     TRIANGLE = 274,
     QUADRILATERAL = 275,
     FACE = 276,
     LINE = 277,
     BEZIER_PATCH = 278,
     OBJECT = 279,
     NEWLINE = 280,
     SPACE = 281,
     FLOAT = 282,
     INTEGER = 283,
     STRING = 284,
     IDENTIFICATOR = 285,
     JUNK = 286
   };
#endif
#define VERTEX 258
#define VERTEX_NORMAL 259
#define TEXTURE_COORD 260
#define MATERIAL 261
#define USE_MAP 262
#define USE_MATERIAL 263
#define GROUP 264
#define SMOOTH_GROUP 265
#define SHADOW_OBJECT 266
#define MAP_LIB 267
#define CINTERP 268
#define MATERIAL_LIB 269
#define RES 270
#define DISPLACEMENTMAP 271
#define RANDOM 272
#define SEPARATOR 273
#define TRIANGLE 274
#define QUADRILATERAL 275
#define FACE 276
#define LINE 277
#define BEZIER_PATCH 278
#define OBJECT 279
#define NEWLINE 280
#define SPACE 281
#define FLOAT 282
#define INTEGER 283
#define STRING 284
#define IDENTIFICATOR 285
#define JUNK 286




/* Copy the first part of user declarations.  */


/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
#line 5 "ff.y"
typedef union YYSTYPE {
  int    i;
  double f;
  char*  s;
} YYSTYPE;
/* Line 191 of yacc.c.  */
#line 154 "ff.tab.c"
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */
#line 12 "ff.y"

#include "ff.h"
#include <string.h>
#include <stdio.h>
int yylex( void );
  
  enum TextureType gTextureType = kRandom;
  char* gLastID = 0;
  int gLastIDLen = 0;
  
  void yy1error( char* s );


/* Line 214 of yacc.c.  */
#line 178 "ff.tab.c"

#if ! defined (yyoverflow) || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# if YYSTACK_USE_ALLOCA
#  define YYSTACK_ALLOC alloca
# else
#  ifndef YYSTACK_USE_ALLOCA
#   if defined (alloca) || defined (_ALLOCA_H)
#    define YYSTACK_ALLOC alloca
#   else
#    ifdef __GNUC__
#     define YYSTACK_ALLOC __builtin_alloca
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC malloc
#  define YYSTACK_FREE free
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   106

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  32
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  51
/* YYNRULES -- Number of rules. */
#define YYNRULES  89
/* YYNRULES -- Number of states. */
#define YYNSTATES  132

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   286

#define YYTRANSLATE(YYX) 						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned char yyprhs[] =
{
       0,     0,     3,     5,     8,     9,    12,    15,    17,    19,
      21,    23,    25,    27,    29,    31,    33,    35,    37,    39,
      41,    43,    45,    48,    52,    54,    56,    61,    65,    67,
      69,    71,    74,    76,    78,    80,    82,    84,    86,    89,
      94,    99,   102,   108,   114,   117,   121,   124,   127,   130,
     133,   136,   138,   142,   147,   153,   158,   160,   162,   164,
     167,   170,   173,   175,   179,   181,   183,   185,   189,   191,
     194,   197,   200,   204,   206,   208,   212,   216,   219,   222,
     223,   225,   228,   231,   234,   237,   241,   243,   246,   248
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const yysigned_char yyrhs[] =
{
      33,     0,    -1,    34,    -1,    34,    35,    -1,    -1,    36,
      44,    -1,    36,    37,    -1,    37,    -1,    38,    -1,    41,
      -1,    68,    -1,    43,    -1,    66,    -1,    67,    -1,    71,
      -1,    72,    -1,    75,    -1,    79,    -1,    77,    -1,    78,
      -1,    82,    -1,    76,    -1,     3,    39,    -1,    40,    40,
      40,    -1,    27,    -1,    28,    -1,     5,    42,    42,    42,
      -1,     5,    42,    42,    -1,    27,    -1,    28,    -1,    63,
      -1,    44,    45,    -1,    45,    -1,    46,    -1,    48,    -1,
      50,    -1,    58,    -1,    59,    -1,    19,    47,    -1,    53,
      53,    53,    25,    -1,    53,    53,    53,    26,    -1,    20,
      49,    -1,    53,    53,    53,    53,    25,    -1,    53,    53,
      53,    53,    26,    -1,    21,    51,    -1,    52,    26,    25,
      -1,    52,    25,    -1,    52,    26,    -1,    52,    53,    -1,
      53,    53,    -1,    26,    54,    -1,    55,    -1,    55,    18,
      56,    -1,    55,    18,    56,    18,    -1,    55,    18,    56,
      18,    57,    -1,    55,    18,    18,    57,    -1,    28,    -1,
      28,    -1,    28,    -1,    22,    60,    -1,    23,    60,    -1,
      60,    61,    -1,    61,    -1,    62,    18,    62,    -1,    62,
      -1,    28,    -1,    64,    -1,     6,    16,    65,    -1,    17,
      -1,     7,    73,    -1,     8,    73,    -1,     4,    69,    -1,
      70,    70,    70,    -1,    27,    -1,    28,    -1,     9,    73,
      25,    -1,    10,    73,    25,    -1,    73,    74,    -1,    73,
      28,    -1,    -1,    30,    -1,    11,    73,    -1,    24,    73,
      -1,    12,    73,    -1,    13,    73,    -1,    14,    80,    25,
      -1,    81,    -1,    80,    81,    -1,    30,    -1,    15,    28,
      28,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short yyrline[] =
{
       0,    65,    65,    68,    69,    72,    75,    76,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    95,   102,   105,   112,   119,   127,   135,   142,
     149,   152,   153,   156,   157,   158,   159,   160,   163,   174,
     175,   178,   189,   190,   193,   208,   209,   210,   213,   214,
     217,   220,   221,   222,   223,   224,   227,   259,   268,   275,
     282,   289,   290,   293,   294,   297,   300,   303,   309,   315,
     321,   330,   338,   341,   348,   356,   365,   374,   375,   376,
     379,   392,   398,   404,   410,   415,   423,   424,   427,   434
};
#endif

#if YYDEBUG || YYERROR_VERBOSE
/* YYTNME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "VERTEX", "VERTEX_NORMAL", "TEXTURE_COORD", 
  "MATERIAL", "USE_MAP", "USE_MATERIAL", "GROUP", "SMOOTH_GROUP", 
  "SHADOW_OBJECT", "MAP_LIB", "CINTERP", "MATERIAL_LIB", "RES", 
  "DISPLACEMENTMAP", "RANDOM", "SEPARATOR", "TRIANGLE", "QUADRILATERAL", 
  "FACE", "LINE", "BEZIER_PATCH", "OBJECT", "NEWLINE", "SPACE", "FLOAT", 
  "INTEGER", "STRING", "IDENTIFICATOR", "JUNK", "$accept", "file", 
  "blocks", "block", "definitions", "definition", "def_vertex_xyz", 
  "vertex_coords", "xyz", "def_texture_uvw", "uvw", "properties", 
  "objects", "object", "triangle", "tri_indexes", "quadrilateral", 
  "quad_indexes", "face", "face_indexes", "complex_index_list", "indexes", 
  "indexes_alone", "xyzi", "uvi", "normali", "line", "bezier_patch", 
  "simple_index_list", "simple_index", "simple_index_int", "texture", 
  "displacement_map", "texture_type", "use_map", "use_material", 
  "def_normal_xyz", "normal_coords", "nxyz", "group", "smooth_group", 
  "ids", "id", "shadow_object", "def_object", "map_lib", "c_interp", 
  "mtl_lib", "filenames", "filename", "res", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,    32,    33,    34,    34,    35,    36,    36,    37,    37,
      37,    37,    37,    37,    37,    37,    37,    37,    37,    37,
      37,    37,    38,    39,    40,    40,    41,    41,    42,    42,
      43,    44,    44,    45,    45,    45,    45,    45,    46,    47,
      47,    48,    49,    49,    50,    51,    51,    51,    52,    52,
      53,    54,    54,    54,    54,    54,    55,    56,    57,    58,
      59,    60,    60,    61,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    70,    71,    72,    73,    73,    73,
      74,    75,    76,    77,    78,    79,    80,    80,    81,    82
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     1,     2,     0,     2,     2,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     2,     3,     1,     1,     4,     3,     1,     1,
       1,     2,     1,     1,     1,     1,     1,     1,     2,     4,
       4,     2,     5,     5,     2,     3,     2,     2,     2,     2,
       2,     1,     3,     4,     5,     4,     1,     1,     1,     2,
       2,     2,     1,     3,     1,     1,     1,     3,     1,     2,
       2,     2,     3,     1,     1,     3,     3,     2,     2,     0,
       1,     2,     2,     2,     2,     3,     1,     2,     1,     3
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned char yydefact[] =
{
       4,     0,     2,     1,     0,     0,     0,     0,    79,    79,
      79,    79,    79,    79,    79,     0,     0,    79,     3,     0,
       7,     8,     9,    11,    30,    66,    12,    13,    10,    14,
      15,    16,    21,    18,    19,    17,    20,    24,    25,    22,
       0,    73,    74,    71,     0,    28,    29,     0,     0,    69,
      70,     0,     0,    81,    83,    84,    88,     0,    86,     0,
      82,     0,     0,     0,     0,     0,     6,     5,    32,    33,
      34,    35,    36,    37,     0,     0,    27,    68,    67,    78,
      80,    77,    75,    76,    85,    87,    89,     0,    38,     0,
      41,     0,    44,     0,     0,    65,    59,    62,    64,    60,
      31,    23,    72,    26,    56,    50,    51,     0,     0,    46,
      47,    48,    49,    61,     0,     0,     0,     0,    45,    63,
       0,    57,    52,    39,    40,     0,    58,    55,    53,    42,
      43,    54
};

/* YYDEFGOTO[NTERM-NUM]. */
static const yysigned_char yydefgoto[] =
{
      -1,     1,     2,    18,    19,    20,    21,    39,    40,    22,
      47,    23,    67,    68,    69,    88,    70,    90,    71,    92,
      93,    89,   105,   106,   122,   127,    72,    73,    96,    97,
      98,    24,    25,    78,    26,    27,    28,    43,    44,    29,
      30,    49,    81,    31,    32,    33,    34,    35,    57,    58,
      36
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -63
static const yysigned_char yypact[] =
{
     -63,    74,    53,   -63,    -8,    10,    56,    34,   -63,   -63,
     -63,   -63,   -63,   -63,   -63,    61,    65,   -63,   -63,     2,
     -63,   -63,   -63,   -63,   -63,   -63,   -63,   -63,   -63,   -63,
     -63,   -63,   -63,   -63,   -63,   -63,   -63,   -63,   -63,   -63,
      -8,   -63,   -63,   -63,    10,   -63,   -63,    56,    75,    52,
      52,    23,    24,    52,    52,    52,   -63,     5,   -63,    66,
      52,    55,    55,    55,    67,    67,   -63,    50,   -63,   -63,
     -63,   -63,   -63,   -63,    -8,    10,    56,   -63,   -63,   -63,
     -63,   -63,   -63,   -63,   -63,   -63,   -63,    68,   -63,    55,
     -63,    55,   -63,    60,    55,   -63,    67,   -63,    79,    67,
     -63,   -63,   -63,   -63,   -63,   -63,    80,    55,    55,   -63,
      51,   -63,   -63,   -63,    67,     0,    62,    55,   -63,   -63,
      71,   -63,    82,   -63,   -63,    64,   -63,   -63,    71,   -63,
     -63,   -63
};

/* YYPGOTO[NTERM-NUM].  */
static const yysigned_char yypgoto[] =
{
     -63,   -63,   -63,   -63,   -63,    83,   -63,   -63,   -38,   -63,
     -43,   -63,   -63,    36,   -63,   -63,   -63,   -63,   -63,   -63,
     -63,   -62,   -63,   -63,   -63,   -27,   -63,   -63,    39,   -21,
      -9,   -63,   -63,   -63,   -63,   -63,   -63,   -63,   -41,   -63,
     -63,    30,   -63,   -63,   -63,   -63,   -63,   -63,   -63,    49,
     -63
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1
static const unsigned char yytable[] =
{
      91,    94,    74,    75,    76,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    15,    16,   120,    37,
      38,    61,    62,    63,    64,    65,    17,   107,   121,   108,
      84,   111,   112,   103,   102,    56,   101,    41,    42,    50,
      51,    52,    53,    54,    55,   116,   117,    60,    82,    83,
      48,    79,    79,    80,    80,   125,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    61,
      62,    63,    64,    65,     3,   113,   118,    17,   113,   104,
      79,    87,    80,    45,    46,   109,   110,   123,   124,   129,
     130,    56,    77,    59,    86,    95,   104,   114,   115,   126,
     128,   131,    66,   100,    99,   119,    85
};

static const unsigned char yycheck[] =
{
      62,    63,    40,    44,    47,     3,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    18,    27,
      28,    19,    20,    21,    22,    23,    24,    89,    28,    91,
      25,    93,    94,    76,    75,    30,    74,    27,    28,     9,
      10,    11,    12,    13,    14,   107,   108,    17,    25,    25,
      16,    28,    28,    30,    30,   117,     3,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    15,    19,
      20,    21,    22,    23,     0,    96,    25,    24,    99,    28,
      28,    26,    30,    27,    28,    25,    26,    25,    26,    25,
      26,    30,    17,    28,    28,    28,    28,    18,    18,    28,
      18,   128,    19,    67,    65,   114,    57
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,    33,    34,     0,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    15,    24,    35,    36,
      37,    38,    41,    43,    63,    64,    66,    67,    68,    71,
      72,    75,    76,    77,    78,    79,    82,    27,    28,    39,
      40,    27,    28,    69,    70,    27,    28,    42,    16,    73,
      73,    73,    73,    73,    73,    73,    30,    80,    81,    28,
      73,    19,    20,    21,    22,    23,    37,    44,    45,    46,
      48,    50,    58,    59,    40,    70,    42,    17,    65,    28,
      30,    74,    25,    25,    25,    81,    28,    26,    47,    53,
      49,    53,    51,    52,    53,    28,    60,    61,    62,    60,
      45,    40,    70,    42,    28,    54,    55,    53,    53,    25,
      26,    53,    53,    61,    18,    18,    53,    53,    25,    62,
      18,    28,    56,    25,    26,    53,    28,    57,    18,    25,
      26,    57
};

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrlab1


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)         \
  Current.first_line   = Rhs[1].first_line;      \
  Current.first_column = Rhs[1].first_column;    \
  Current.last_line    = Rhs[N].last_line;       \
  Current.last_column  = Rhs[N].last_column;
#endif

/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)

# define YYDSYMPRINT(Args)			\
do {						\
  if (yydebug)					\
    yysymprint Args;				\
} while (0)

# define YYDSYMPRINTF(Title, Token, Value, Location)		\
do {								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr, 					\
                  Token, Value);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (cinluded).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_stack_print (short *bottom, short *top)
#else
static void
yy_stack_print (bottom, top)
    short *bottom;
    short *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_reduce_print (int yyrule)
#else
static void
yy_reduce_print (yyrule)
    int yyrule;
#endif
{
  int yyi;
  unsigned int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %u), ",
             yyrule - 1, yylno);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytname [yyrhs[yyi]]);
  YYFPRINTF (stderr, "-> %s\n", yytname [yyr1[yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (Rule);		\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YYDSYMPRINT(Args)
# define YYDSYMPRINTF(Title, Token, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

#endif /* !YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep)
#else
static void
yysymprint (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (yytype < YYNTOKENS)
    {
      YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
# ifdef YYPRINT
      YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
    }
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yydestruct (int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yytype, yyvaluep)
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  switch (yytype)
    {

      default:
        break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM);
# else
int yyparse ();
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM)
# else
int yyparse (YYPARSE_PARAM)
  void *YYPARSE_PARAM;
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  
  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;



#define YYPOPSTACK   (yyvsp--, yyssp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YYDSYMPRINTF ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %s, ", yytname[yytoken]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 22:
#line 96 "ff.y"
    {
  AddVertex( gVertex );
  ResetVertexInfo();
;}
    break;

  case 24:
#line 106 "ff.y"
    {
  gVertex.xyz[ gVertex.index ] = yy1lval.f;
  gVertex.index++;
;}
    break;

  case 25:
#line 113 "ff.y"
    {
  gVertex.xyz[ gVertex.index ] = yy1lval.i;
  gVertex.index++;
;}
    break;

  case 26:
#line 120 "ff.y"
    {
  gFeatures.textures++;
  /* TBD:Eric Paquette: Implement if needed. */
  ResetTextureCoordinateInfo();
;}
    break;

  case 27:
#line 128 "ff.y"
    {
  gFeatures.textures++;
  AddTextureCoordinate2d( &gTextureCoord );
  ResetTextureCoordinateInfo();
;}
    break;

  case 28:
#line 136 "ff.y"
    {
  gTextureCoord.uvw[ gTextureCoord.index ] = yy1lval.f;
  gTextureCoord.index++;
;}
    break;

  case 29:
#line 143 "ff.y"
    {
  gTextureCoord.uvw[ gTextureCoord.index ] = yy1lval.i;
  gTextureCoord.index++;
;}
    break;

  case 38:
#line 164 "ff.y"
    {
  //BEGIN( INITIAL );
  //printf( "t state %d\n", yy_start );
  //printf( "finished face t\n" );
  gFeatures.faces++;
  AddFace( gVertices.xyzi, gVertices.index );
  ResetVerticesInfo();
;}
    break;

  case 41:
#line 179 "ff.y"
    {
  //BEGIN( INITIAL );
  //printf( "q state %d\n", yy_start );
  //printf( "finished face q\n" );
  gFeatures.faces++;
  AddFace( gVertices.xyzi, gVertices.index );
  ResetVerticesInfo();
;}
    break;

  case 44:
#line 194 "ff.y"
    {
  //BEGIN( INITIAL );
  //printf( "f state %d\n", yy_start );
  //printf( "finished face\n" );
  gFeatures.faces++;
  if ( gVertices.usedN && gVertices.usedUV ) 
    AddFace( gVertices.xyzi, gVertices.uvi, gVertices.ni, gVertices.index );
  else if ( !gVertices.usedN )
    AddFace( gVertices.xyzi, gVertices.index );
  else
    AddFace( gVertices.xyzi, gVertices.ni, gVertices.index );
  ResetVerticesInfo();
;}
    break;

  case 56:
#line 228 "ff.y"
    {
  if ( gVertices.index == gVertices.maxIndex )
  {
    /* Increment the amount of storage */
    int old_maxIndex = gVertices.maxIndex;
    int *old_xyzi = gVertices.xyzi;
    int *old_uvi = gVertices.uvi;
    int *old_ni = gVertices.ni;
    
    gVertices.maxIndex += 10;
    gVertices.xyzi = new int[gVertices.maxIndex];
    gVertices.uvi = new int[gVertices.maxIndex];
    gVertices.ni = new int[gVertices.maxIndex];

    for ( int i = 0 ; i < old_maxIndex ; i++ )
    {
      gVertices.xyzi[ i ] = old_xyzi[ i ];
      gVertices.uvi[ i ] = old_uvi[ i ];
      gVertices.ni[ i ] = old_ni[ i ];
    }

    delete[] old_xyzi;
    delete[] old_uvi;
    delete[] old_ni;
  }
  
  gVertices.xyzi[ gVertices.index ] = yy1lval.i;
  gVertices.index++;
;}
    break;

  case 57:
#line 260 "ff.y"
    {
  /* - 1 because the index is incremented in vertex_xyz which is called
     before */
  gVertices.usedUV = true;
  gVertices.uvi[ gVertices.index - 1 ] = yy1lval.i;
;}
    break;

  case 58:
#line 269 "ff.y"
    {
  gVertices.usedN = true;
  gVertices.ni[ gVertices.index - 1 ] = yy1lval.i;
;}
    break;

  case 59:
#line 276 "ff.y"
    {
  gFeatures.lines++;
  /* TBD:Eric Paquette: Implement if needed */
;}
    break;

  case 60:
#line 283 "ff.y"
    {
  gFeatures.bezierPatches++;
  /* TBD:Eric Paquette: Implement if needed */
;}
    break;

  case 67:
#line 304 "ff.y"
    {
  AddDisplacementMap( /*gTextureType*/ );
;}
    break;

  case 68:
#line 310 "ff.y"
    {
  gTextureType = kRandom;
;}
    break;

  case 69:
#line 316 "ff.y"
    {
  gFeatures.maps++;
;}
    break;

  case 70:
#line 322 "ff.y"
    {
  gFeatures.materials++;
  gCurrentShader = GetShader( gLastID );
//  printf( "Material id {%s}\n", gLastID );
;}
    break;

  case 71:
#line 331 "ff.y"
    {
  gFeatures.normals++;
  AddNormal( gNormal );
  ResetNormalInfo();
;}
    break;

  case 73:
#line 342 "ff.y"
    {
  gNormal.xyz[ gNormal.index ] = yy1lval.f;
  gNormal.index++;
;}
    break;

  case 74:
#line 349 "ff.y"
    {
  gNormal.xyz[ gNormal.index ] = yy1lval.i;
  gNormal.index++;
;}
    break;

  case 75:
#line 357 "ff.y"
    {
  gFeatures.groups++;
  //BEGIN( INITIAL );
  //printf( "g state %d\n", yy_start );
  /* TBD:Eric Paquette: Implement if ever needed. */
;}
    break;

  case 76:
#line 366 "ff.y"
    {
  gFeatures.smoothGroups++;
  //BEGIN( INITIAL );
  //printf( "s state %d\n", yy_start );
  /* TBD:Eric Paquette: Implement if ever needed. */
;}
    break;

  case 80:
#line 380 "ff.y"
    {
  if ( (size_t)gLastIDLen < strlen( yy1lval.s ) + 1 )
  {
    gLastIDLen = strlen( yy1lval.s ) + 1;
    delete[] gLastID;
    gLastID = new char[ gLastIDLen ];
  }
    
  strcpy( gLastID, yy1lval.s );
;}
    break;

  case 81:
#line 393 "ff.y"
    {
  gFeatures.shadowObjects++;
;}
    break;

  case 82:
#line 399 "ff.y"
    {
  /* TBD:Eric Paquette: Implement if needed */
;}
    break;

  case 83:
#line 405 "ff.y"
    {
  gFeatures.mapLibs++;
;}
    break;

  case 84:
#line 411 "ff.y"
    {
;}
    break;

  case 85:
#line 416 "ff.y"
    {
  gFeatures.mtlLibs++;
  //BEGIN( INITIAL );
  //printf( "s state %d\n", yy_start );
;}
    break;

  case 88:
#line 428 "ff.y"
    {
  if ( !IsDefaultMaterialFile( yy1lval.s ) )
    LoadMaterialFile( yy1lval.s );
;}
    break;

  case 89:
#line 435 "ff.y"
    {
  /* TBD:Eric Paquette: Implement if needed */
;}
    break;


    }

/* Line 999 of yacc.c.  */
#line 1491 "ff.tab.c"

  yyvsp -= yylen;
  yyssp -= yylen;


  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  int yytype = YYTRANSLATE (yychar);
	  const char* yyprefix;
	  char *yymsg;
	  int yyx;

	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  int yyxbegin = yyn < 0 ? -yyn : 0;

	  /* Stay within bounds of both yycheck and yytname.  */
	  int yychecklim = YYLAST - yyn;
	  int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
	  int yycount = 0;

	  yyprefix = ", expecting ";
	  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      {
		yysize += yystrlen (yyprefix) + yystrlen (yytname [yyx]);
		yycount += 1;
		if (yycount == 5)
		  {
		    yysize = 0;
		    break;
		  }
	      }
	  yysize += (sizeof ("syntax error, unexpected ")
		     + yystrlen (yytname[yytype]));
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "syntax error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[yytype]);

	      if (yycount < 5)
		{
		  yyprefix = ", expecting ";
		  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
		    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
		      {
			yyp = yystpcpy (yyp, yyprefix);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yyprefix = " or ";
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("syntax error; also virtual memory exhausted");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror ("syntax error");
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      /* Return failure if at end of input.  */
      if (yychar == YYEOF)
        {
	  /* Pop the error token.  */
          YYPOPSTACK;
	  /* Pop the rest of the stack.  */
	  while (yyss < yyssp)
	    {
	      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
	      yydestruct (yystos[*yyssp], yyvsp);
	      YYPOPSTACK;
	    }
	  YYABORT;
        }

      YYDSYMPRINTF ("Error: discarding", yytoken, &yylval, &yylloc);
      yydestruct (yytoken, &yylval);
      yychar = YYEMPTY;

    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*----------------------------------------------------.
| yyerrlab1 -- error raised explicitly by an action.  |
`----------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
      yydestruct (yystos[yystate], yyvsp);
      yyvsp--;
      yystate = *--yyssp;

      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;


  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*----------------------------------------------.
| yyoverflowlab -- parser overflow comes here.  |
`----------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}


#line 440 "ff.y"


#include "lex.yy1.c"

ffVertex gVertex;
ffNormal gNormal;

TextureCoord gTextureCoord;

Vertices gVertices;

Features gFeatures;


void yy1error( char* s )
{
  fprintf( stderr, "[ERROR] line %d : %s\n", yy1lineno, s );
  fprintf( stderr, "(%s)\n", yy1text );
}

//#if (!defined(__sgi))
char  yy1sbuf[40];
char* yy1sptr = yy1sbuf;
//#endif

bool yy1Init( const char* szFileName )
{
  //BEGIN( INITIAL );
  yy1in = fopen( szFileName, "r" );
  if ( yy1in == 0 )
  {
    fprintf( stderr, "[ERROR] yy1Init : could not open file [%s]\n",
             szFileName );
    return( false );
  }
  
  yy1lineno = 1;
  yy1leng = 0;
  yy1sbuf[0] = '\0';
  yy1sptr = yy1sbuf;
  
  return( true );
}

void yy1End()
{
  CloseFaceGroup();
  fclose( yy1in );
  yy1in = stdin;
}



