#ifndef _MAIN_H
#define _MAIN_H

/*!
  \file main.h
  \brief Declaration for the Main class.

  \author Eric Paquette
  \date Fri Sep 24 16:01:29 1999

  This file contains the declaration of the Main class.
*/


/*
******************************************************************************
**
** Forward declarations
**
******************************************************************************
*/


class ofstream;
class QString;


/*
******************************************************************************
**
** Functions declarations
**
******************************************************************************
*/


void ProcessSomeEvents( int time = 10 );
void AddProgressBar( int num );
void UpdateProgress( int num );
void RemoveProgressBar();
void StatusMessage( const QString& message );
void StatusMessage( const QString& message, int timeMS );

extern std::ofstream errorFile;

#define serr cerr
//#define serr errorFile


/* End of file */
/****************************************************************************/
#endif /* _MAIN_H */
